Btrfs: Add version strings on module load
authorChris Mason <chris.mason@oracle.com>
Wed, 23 Jul 2008 16:12:13 +0000 (12:12 -0400)
committerChris Mason <chris.mason@oracle.com>
Thu, 25 Sep 2008 15:04:05 +0000 (11:04 -0400)
Signed-off-by: Chris Mason <chris.mason@oracle.com>
fs/btrfs/Makefile
fs/btrfs/super.c
fs/btrfs/version.sh [new file with mode: 0644]

index 0e2dcc7..f8a38b0 100644 (file)
@@ -14,8 +14,12 @@ else
 # Normal Makefile
 
 KERNELDIR := /lib/modules/`uname -r`/build
-all:
+all: version
        $(MAKE) -C $(KERNELDIR) M=`pwd` modules
+
+version:
+       bash version.sh
+
 modules_install:
        $(MAKE) -C $(KERNELDIR) M=`pwd` modules_install
 clean:
index 5e28cf5..4cb6aac 100644 (file)
@@ -45,6 +45,7 @@
 #include "print-tree.h"
 #include "xattr.h"
 #include "volumes.h"
+#include "version.h"
 
 #define BTRFS_SUPER_MAGIC 0x9123683E
 
@@ -605,6 +606,8 @@ static int __init init_btrfs_fs(void)
        err = register_filesystem(&btrfs_fs_type);
        if (err)
                goto unregister_ioctl;
+
+       printk(KERN_INFO "%s loaded\n", BTRFS_BUILD_VERSION);
        return 0;
 
 unregister_ioctl:
diff --git a/fs/btrfs/version.sh b/fs/btrfs/version.sh
new file mode 100644 (file)
index 0000000..fd9b53d
--- /dev/null
@@ -0,0 +1,43 @@
+#!/bin/bash
+#
+# determine-version -- report a useful version for releases
+#
+# Copyright 2008, Aron Griffis <agriffis@n01se.net>
+# Copyright 2008, Oracle
+# Released under the GNU GPLv2
+v="Btrfs v0.15"
+
+which hg > /dev/null
+if [ $? == 0 ]; then
+       last=$(hg tags | grep -m1 -o '^v[0-9.]\+')
+        
+       # now check if the repo has commits since then...
+       if [[ $(hg id -t) == $last || \
+           $(hg di -r "$last:." | awk '/^diff/{print $NF}' | sort -u) == .hgtags ]]
+       then
+           # check if it's dirty
+           if [[ $(hg id | cut -d' ' -f1) == *+ ]]; then
+               v=$last+
+           else
+               v=$last
+           fi
+       else
+           # includes dirty flag
+           v=$last+$(hg id -i)
+       fi
+fi
+echo "#ifndef __BUILD_VERSION" > .build-version.h
+echo "#define __BUILD_VERSION" >> .build-version.h
+echo "#define BTRFS_BUILD_VERSION \"Btrfs $v\"" >> .build-version.h
+echo "#endif" >> .build-version.h
+
+diff -q version.h .build-version.h >& /dev/null
+
+if [ $? == 0 ]; then
+    rm .build-version.h
+    exit 0
+fi
+
+mv .build-version.h version.h